
HRESULT CSoundsDoc::ConvertAsIsToMono()
{
	//Konvertiertes Wavefile erstellen
	TCHAR TempFolder[MAX_PATH];
	GetTempPath(MAX_PATH,TempFolder);

	CWaveFile* m_pTempWaveMonoConverted = new CWaveFile;
	WAVEFORMATEX wfx;
	CString FileNameStandard;
  UINT dwDataWrote;

	//Standardformatfile herstellen
	wfx.cbSize=0;
	wfx.wFormatTag=WAVE_FORMAT_PCM;
	wfx.nChannels=1;

	wfx.wBitsPerSample=m_BitRate;
	wfx.nSamplesPerSec=m_intSamples;
	wfx.nBlockAlign=wfx.wBitsPerSample/8;
	wfx.nAvgBytesPerSec=wfx.nBlockAlign*wfx.nSamplesPerSec;

	FileNameStandard=(CString)TempFolder+"~TempWaveMono.wav";
  LPTSTR strFileNameStandard = FileNameStandard.GetBuffer(MAX_PATH);
	m_pTempWaveMonoConverted->Open(strFileNameStandard,&wfx,WAVEFILE_WRITE);

	if (m_BitRate==8) 
	{
		for(UINT register x=m_bReadLinkerKanal?0:1;x<m_SoundBufferSize;x+=2)	
			{
				BYTE Wert=*((BYTE*)(m_pSoundBuffer)+x);
				m_pTempWaveMonoConverted->Write(1,&Wert,&dwDataWrote);
			}
	}
	else
	{
		for(UINT register x=m_bReadLinkerKanal?0:2;x<m_SoundBufferSize;x+=4)	
			{
				BYTE Wert=*((BYTE*)(m_pSoundBuffer)+x);
				m_pTempWaveMonoConverted->Write(1,&Wert,&dwDataWrote);
				BYTE Wert2=*((BYTE*)(m_pSoundBuffer)+x+1);
				m_pTempWaveMonoConverted->Write(1,&Wert2,&dwDataWrote);
			}
	}
	m_pTempWaveMonoConverted->Close();
	m_pTempWaveMonoConverted->ResetFile();
	SAFE_DELETE(m_pTempWaveMonoConverted);

	CreateAbbild(strFileNameStandard);

	return S_OK;
}

HRESULT CSoundsDoc::CreateConvertedTempWaveForSoundPlay(LPTSTR Filename)
{
	HRESULT hr;
	CWaveFile	waveFile;
	WAVEFORMATEX wfx;
	CString FileNameStandard;
//	BYTE* pSoundBufferConverted;
	INT Faktor;
  UINT dwDataWrote;
/*
	AfxMessageBox("Wegen einer Samplingrate>48kHz wird \
eine temporre Wavedatei angelegt. Das ist erforderlich, \
damit die DirectSound WIEDERGABE einwandfrei funktioniert. \
Fr die BERECHNUNGEN wird aber weiterhin das Original verwendet.");
*/

	m_pTempWaveConverted = new CWaveFile;

	//Standardformatfile herstellen
	wfx.cbSize=0;
	wfx.wFormatTag=WAVE_FORMAT_PCM;
	wfx.nChannels=1;

	if (m_BitRate==8) 
		wfx.wBitsPerSample=8;
	else
		wfx.wBitsPerSample=16;

	switch(m_intSamples) 
	{
		case 192000:
			Faktor = 4;
			wfx.nSamplesPerSec=48000;
			break;
		case 96000:
			Faktor = 2;
			wfx.nSamplesPerSec=48000;
			break;
		case 88200:
			Faktor = 2;
			wfx.nSamplesPerSec=44100;
			break;
		case 64000:
			Faktor = 2;
			wfx.nSamplesPerSec=32000;
			break;
	}

	wfx.nBlockAlign=wfx.wBitsPerSample/8;
	wfx.nAvgBytesPerSec=wfx.nBlockAlign*wfx.nSamplesPerSec;

	//Konvertiertes Wavefile erstellen
	TCHAR TempFolder[MAX_PATH];
	GetTempPath(MAX_PATH,TempFolder);

	FileNameStandard=(CString)TempFolder+"~TempWave.wav";
  LPTSTR strFileNameStandard = FileNameStandard.GetBuffer(MAX_PATH);
	m_pTempWaveConverted->Open(strFileNameStandard,&wfx,WAVEFILE_WRITE);

// Load the wave file
//  waveFile.Open( Filename, NULL, WAVEFILE_READ );
//	waveFile.ResetFile();
//  dwFileSize=waveFile.GetSize();

	//Soundpuffer fr reduziertes File reservieren
//	m_pSoundBufferConverted=(BYTE*)malloc (sizeof(BYTE)*m_SoundBufferSize/Faktor);
	m_SoundBufferConvertedSize=m_SoundBufferSize/Faktor;
	m_AktualPlaySoundBufferSize=m_SoundBufferConvertedSize;

	DOUBLE Wert1,Wert2,Wert3,Wert4;
	DOUBLE WertA,WertB,WertC,WertD;
	DOUBLE WertNeu;
	BYTE Wert,Eintrag1,Eintrag2;
	DWORD cT;

/*
	if (Faktor==2) 
	{
		for(UINT register x=0;x<(m_BitRate==8?m_SoundBufferSize:m_SoundBufferSize/2);x+=2)	
		{
			Wert1=m_BitRate==8?*((BYTE*)(m_pSoundBuffer)+x):*((short*)(m_pSoundBuffer)+x);
			Wert2=m_BitRate==8?*((BYTE*)(m_pSoundBuffer)+x+1):*((short*)(m_pSoundBuffer)+x+1);
			if (m_BitRate==8) 
			{
				Wert=(BYTE)((Wert1+Wert2)/Faktor);
				pWert=&Wert;
			}
			else
			{
				WertShort=(short)((Wert1+Wert2)/Faktor);
				pWert=&WertShort;
			}
			m_pTempWaveConverted->Write(m_BitRate==8?1:2,&Wert,&dwDataWrote);
		}
	}
*/

	if ((Faktor==2)&&(m_BitRate==8))
	{
		for( cT = 0; cT < m_SoundBufferSize; cT+=2 )
		{
			Wert1=(DOUBLE)(*((BYTE*)(m_pSoundBuffer)+cT));
			Wert2=(DOUBLE)(*((BYTE*)(m_pSoundBuffer)+cT+1));
			Wert=(BYTE)((Wert1+Wert2)/Faktor);
//			*((BYTE*)(m_pSoundBufferConverted)+cT/2)=Wert;
			m_pTempWaveConverted->Write(1,&Wert,&dwDataWrote);
		}
	}
	if ((Faktor==2)&&(m_BitRate==16))
	{
		for( cT = 0; cT < m_SoundBufferSize; cT+=4)
		{
			Wert1=(DOUBLE)(*((BYTE*)(m_pSoundBuffer)+cT));
			Wert2=(DOUBLE)(*((BYTE*)(m_pSoundBuffer)+cT+1));
			WertA=Wert1+Wert2*256;
			if (WertA>=32768)
							WertA-=65536;

			Wert1=(DOUBLE)(*((BYTE*)(m_pSoundBuffer)+cT+2));
			Wert2=(DOUBLE)(*((BYTE*)(m_pSoundBuffer)+cT+3));
			WertB=Wert1+Wert2*256;
			if (WertB>=32768)
							WertB-=65536;
			
			WertNeu=(WertA+WertB)/Faktor;
			if (WertNeu<=0)
							WertNeu+=65536;
			DWORD WertJetzt=(DWORD)WertNeu;
			Eintrag1=(BYTE)(WertJetzt%256);
			Eintrag2=(BYTE)((WertJetzt-Eintrag1)/256);

//			*((BYTE*)(m_pSoundBufferConverted)+cT/2)=Eintrag1;
//			*((BYTE*)(m_pSoundBufferConverted)+cT/2+1)=Eintrag2;
		
			m_pTempWaveConverted->Write(1,&Eintrag1,&dwDataWrote);
			m_pTempWaveConverted->Write(1,&Eintrag2,&dwDataWrote);
		}
	}

	
	if ((Faktor==4)&&(m_BitRate==8))
	{
		for( cT = 0; cT < m_SoundBufferSize; cT+=4 )
		{
			Wert1=(DOUBLE)(*((BYTE*)(m_pSoundBuffer)+cT));
			Wert2=(DOUBLE)(*((BYTE*)(m_pSoundBuffer)+cT+1));
			Wert3=(DOUBLE)(*((BYTE*)(m_pSoundBuffer)+cT+2));
			Wert4=(DOUBLE)(*((BYTE*)(m_pSoundBuffer)+cT+3));
			Wert=(BYTE)((Wert1+Wert2+Wert3+Wert4)/Faktor);
//			*((BYTE*)(m_pSoundBufferConverted)+cT/4)=Wert;
			m_pTempWaveConverted->Write(1,&Wert,&dwDataWrote);
		}
	}
	if ((Faktor==4)&&(m_BitRate==16))
	{
		for( cT = 0; cT < m_SoundBufferSize; cT+=8 )
		{
			Wert1=(DOUBLE)(*((BYTE*)(m_pSoundBuffer)+cT));
			Wert2=(DOUBLE)(*((BYTE*)(m_pSoundBuffer)+cT+1));
			WertA=Wert1+Wert2*256;
			if (WertA>=32768)
							WertA-=65536;

			Wert1=(DOUBLE)(*((BYTE*)(m_pSoundBuffer)+cT+2));
			Wert2=(DOUBLE)(*((BYTE*)(m_pSoundBuffer)+cT+3));
			WertB=Wert1+Wert2*256;
			if (WertB>=32768)
							WertB-=65536;
			
			Wert1=(DOUBLE)(*((BYTE*)(m_pSoundBuffer)+cT+4));
			Wert2=(DOUBLE)(*((BYTE*)(m_pSoundBuffer)+cT+5));
			WertC=Wert1+Wert2*256;
			if (WertC>=32768)
							WertC-=65536;

			Wert1=(DOUBLE)(*((BYTE*)(m_pSoundBuffer)+cT+6));
			Wert2=(DOUBLE)(*((BYTE*)(m_pSoundBuffer)+cT+7));
			WertD=Wert1+Wert2*256;
			if (WertD>=32768)
							WertD-=65536;

			WertNeu=(WertA+WertB+WertC+WertD)/Faktor;
			if (WertNeu<=0)
							WertNeu+=65536;
			DWORD WertJetzt=(DWORD)WertNeu;
			Eintrag1=(BYTE)(WertJetzt%256);
			Eintrag2=(BYTE)((WertJetzt-Eintrag1)/256);

//			*((BYTE*)(m_pSoundBufferConverted)+cT/4)=Eintrag1;
//			*((BYTE*)(m_pSoundBufferConverted)+cT/4+1)=Eintrag2;
			
			m_pTempWaveConverted->Write(1,&Eintrag1,&dwDataWrote);
			m_pTempWaveConverted->Write(1,&Eintrag2,&dwDataWrote);
		}
	}
//	free(m_pSoundBufferConverted);
	
//  waveFile.Close();
	m_pTempWaveConverted->Close();
	m_pTempWaveConverted->ResetFile();
	SAFE_DELETE(m_pTempWaveConverted);
// 	delete waveFile;

	
	g_bIsConvertedPlay=TRUE;
	m_SampleRateConverted=wfx.nSamplesPerSec;
	m_BitRateConverted=wfx.wBitsPerSample;

	
//	//Konstante Bildrate durch regelmige Notifys herstellen
//  DWORD dwNotifySize = m_SampleRateConverted/5; //m_NumFFTPoints*8;
//	m_dwNumPlayNotifications = 16;//(FileSize/nBlockAlign)/dwNotifySize+1;
//  dwNotifySize -= dwNotifySize % wfx.nBlockAlign;   

  // Create a new sound
//  SAFE_DELETE( m_pStreamingSound );
  SAFE_DELETE( m_pSound );
		
	    // Load the wave file into a DirectSound buffer
			if( FAILED( hr = theApp.m_pSoundManager->Create( &m_pSound, strFileNameStandard, 0, GUID_NULL ) ) )
			{
        // Not a critical failure, so just update the status
        DXTRACE_ERR_NOMSGBOX( TEXT("Create"), hr );
        return S_FALSE; 
			}

	return S_OK;
//	// Set up the direct sound buffer.  Request the NOTIFY flag, so
//  // that we are notified as the sound buffer plays.  Note, that using this flag
//  // may limit the amount of hardware acceleration that can occur. 
//  if( FAILED( theApp.m_pSoundManager->CreateStreaming( &m_pStreamingSound, strFileNameStandard, 
//       DSBCAPS_CTRLPOSITIONNOTIFY|DSBCAPS_GETCURRENTPOSITION2, 
//       GUID_NULL, m_dwNumPlayNotifications, dwNotifySize, m_hEventPlayBufferNotify ) ) )
//			AfxMessageBox("Failed: Create Streaming. in: ConvertWave");
}
