/////////////////////////////////////////////////////////////////////////////
// $Header: /cvsroot/mmconvert/mmconvert/MMConvert/Src/Common/Mp3Converter.h,v 1.2 2005/09/20 06:19:14 ping235 Exp $
//
/////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2005 ping235.  All rights reserved.
/////////////////////////////////////////////////////////////////////////////
//
//  This file is subject to the terms of the GNU General Public License as
//  published by the Free Software Foundation.  A copy of this license is
//  included with this software distribution in the file COPYING.  If you
//  do not have a copy, you may obtain a copy by writing to the Free
//  Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
//
//  This software is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details
/////////////////////////////////////////////////////////////////////////////
// Change Log
//
// Date          Developer             Changes
// $Date: 2005/09/20 06:19:14 $        $Author: ping235 $              $Name:  $
//
/////////////////////////////////////////////////////////////////////////////
// CVS Log
// $Log: Mp3Converter.h,v $
// Revision 1.2  2005/09/20 06:19:14  ping235
// added lame mp3 codec support
//
// Revision 1.1.1.1  2005/08/02 05:17:23  ping235
// initial,GUI 1.0.0.0,CMD 1.3.0.1
//
//////////////////////////////////////////////////////////////////////////////

#pragma once
#include ".\converter.h"

/***********************************************************************************************
Mp3תתʽļMp3ʽ
************************************************************************************************/
extern "C" const GUID __declspec(selectany) CLSID_WaveDest =
    {0x3C78B8E2,0x6C4D,0x11D1,{0xAD,0xE2,0x00,0x00,0xF8,0x75,0x4B,0x99}};

//mp3 encoder(built-in Windows)
static const TCHAR c_tszMp3CodecDispName[] = _T("@device:cm:{33D9A761-90C8-11D0-BD43-00A0C911CE86}\\85MPEG Layer-3");
//lame mp3 encoder
static const TCHAR c_tszLameMp3CodecDispName[] = _T("@device:sw:{083863F1-70DE-11D0-BD40-00A0C911CE86}\\{B8D27088-DF5F-4B7C-98DC-0E91A1696286}");

class CMp3Converter:public CConverter
{
private:
	bool m_bEnableMp3Compress;
	CString m_strMp3Codec;//mp3 codec's dispname

	//ҪתƵͨţÿͨ
	//һļ
	std::list<int> m_lstAudioChan;
	CString m_strOutputFileName;

	BOOL BuildGraph(void);
	CString GetOutputFileName(int);

public:
	CMp3Converter();
	~CMp3Converter(void);
	// תԴļ,ȵô˺
	void SetInputFileName(LPCTSTR lpszFileName);
	void SetOutputFileName(LPCTSTR lpszFileName);
	// ǷMp3ѹMp3ѹĸʽΪWav
	void EnableMp3Compress(bool bEnable, CString strMp3Codec = c_tszMp3CodecDispName);
	bool ParseCmdLine(CStringList& strlSpecParam);
};
