// NotenbildFrame.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "Sounds.h"
#include "NotenbildFrame.h"
#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CNotenbildFrame

IMPLEMENT_DYNCREATE(CNotenbildFrame, CMDIChildWnd)

CNotenbildFrame::CNotenbildFrame()
{
}

CNotenbildFrame::~CNotenbildFrame()
{
}


BEGIN_MESSAGE_MAP(CNotenbildFrame, CMDIChildWnd)
	//{{AFX_MSG_MAP(CNotenbildFrame)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten CNotenbildFrame 

BOOL CNotenbildFrame::PreCreateWindow(CREATESTRUCT& cs) 
{
	cs.style |= WS_THICKFRAME;
	cs.style |= WS_BORDER;
  cs.style |= (WS_MINIMIZEBOX|WS_MAXIMIZEBOX);
  if( !CMDIChildWnd::PreCreateWindow(cs) )
		return FALSE;
	return TRUE;
}

int CNotenbildFrame::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CMDIChildWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndDlgBar.Create(this, IDD_NOTENBILD,CBRS_RIGHT|CBRS_TOOLTIPS|CBRS_FLYBY, IDD_NOTENBILD))
	{
		TRACE0("Failed to create DlgBar\n");
		return -1;      // fail to create
	}
	if (*theApp.GetIniAllgemeinGrundschulprofil()) m_wndDlgBar.ShowWindow(SW_HIDE);
	DoPlacement(TRUE);	//GetIt
	
	return 0;
}

void CNotenbildFrame::OnDestroy() 
{
	CMDIChildWnd::OnDestroy();
	DoPlacement(FALSE);	//PutIt
}

void CNotenbildFrame::DoPlacement(BOOL bGetit)
{
	CSoundsApp *app=(CSoundsApp *)AfxGetApp();
	WINDOWPLACEMENT wp;
	if (bGetit) 
		wp=app->GetWP(NOTENBILD);
	else
		this->GetWindowPlacement(&wp);

	app->SwitchWindowplacementAbsolutePercent(!bGetit,&wp);
	
	if (bGetit) 
		this->SetWindowPlacement(&wp);
	else
		app->PutWP(wp,NOTENBILD);
}

