// SaveProfileDLG.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "Sounds.h"
#include "SaveProfileDLG.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Dialogfeld CSaveProfileDLG 


CSaveProfileDLG::CSaveProfileDLG(CWnd* pParent /*=NULL*/)
	: CDialog(CSaveProfileDLG::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSaveProfileDLG)
	m_Filename = _T("");
	m_FilenameLong = _T("");
	//}}AFX_DATA_INIT
}


void CSaveProfileDLG::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSaveProfileDLG)
	DDX_Text(pDX, IDC_EDIT_FILENAME, m_Filename);
	DDX_Text(pDX, IDC_STATIC_FILENAME, m_FilenameLong);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSaveProfileDLG, CDialog)
	//{{AFX_MSG_MAP(CSaveProfileDLG)
	ON_EN_CHANGE(IDC_EDIT_FILENAME, OnChangeEditFilename)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten CSaveProfileDLG 

BOOL CSaveProfileDLG::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	UpdateData(FALSE);	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX-Eigenschaftenseiten sollten FALSE zurckgeben
}

void CSaveProfileDLG::OnOK() 
{
	UpdateData(TRUE);	
	CDialog::OnOK();
}

void CSaveProfileDLG::OnChangeEditFilename() 
{
	UpdateData(TRUE);
	m_FilenameLong="SoundsUserProfil-"+m_Filename+".ini";
	UpdateData(FALSE);
}
