// SonoFrame.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "Sounds.h"
#include "SonoFrame.h"
#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSonoFrame

IMPLEMENT_DYNCREATE(CSonoFrame, CMDIChildWnd)

CSonoFrame::CSonoFrame()
{
}

CSonoFrame::~CSonoFrame()
{
}


BEGIN_MESSAGE_MAP(CSonoFrame, CMDIChildWnd)
	//{{AFX_MSG_MAP(CSonoFrame)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten CSonoFrame 

BOOL CSonoFrame::PreCreateWindow(CREATESTRUCT& cs) 
{
	cs.style |= WS_THICKFRAME;
	cs.style |= WS_BORDER;
  cs.style |= (WS_MINIMIZEBOX|WS_MAXIMIZEBOX);
  if( !CMDIChildWnd::PreCreateWindow(cs) )
		return FALSE;
	return TRUE;
}


int CSonoFrame::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CMDIChildWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndDlgBar.Create(this, IDD_SONO_DLG,CBRS_RIGHT|CBRS_TOOLTIPS|CBRS_FLYBY, IDD_SONO_DLG))
	{
		TRACE0("Failed to create DlgBar\n");
		return -1;      // fail to create
	}
	if (*theApp.GetIniAllgemeinGrundschulprofil()) m_wndDlgBar.ShowWindow(SW_HIDE);
	
	DoPlacement(TRUE);	//GetIt
	
	return 0;
}



void CSonoFrame::OnDestroy() 
{
	CMDIChildWnd::OnDestroy();
	DoPlacement(FALSE);	//PutIt
}

void CSonoFrame::DoPlacement(BOOL bGetit)
{
	CSoundsApp *app=(CSoundsApp *)AfxGetApp();
	WINDOWPLACEMENT wp;
	if (bGetit) 
		wp=app->GetWP(SONO);
	else
		this->GetWindowPlacement(&wp);

	app->SwitchWindowplacementAbsolutePercent(!bGetit,&wp);
	
	if (bGetit) 
		this->SetWindowPlacement(&wp);
	else
		app->PutWP(wp,SONO);
}

