// AnalyseFrame.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "Sounds.h"
#include "AnalyseFrame.h"
#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAnalyseFrame

IMPLEMENT_DYNCREATE(CAnalyseFrame, CMDIChildWnd)

CAnalyseFrame::CAnalyseFrame()
{
}

CAnalyseFrame::~CAnalyseFrame()
{
}


BEGIN_MESSAGE_MAP(CAnalyseFrame, CMDIChildWnd)
	//{{AFX_MSG_MAP(CAnalyseFrame)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten CAnalyseFrame 

BOOL CAnalyseFrame::PreCreateWindow(CREATESTRUCT& cs) 
{
	cs.style |= WS_THICKFRAME;
	cs.style |= WS_BORDER;
  cs.style |= (WS_MINIMIZEBOX|WS_MAXIMIZEBOX);
  if( !CMDIChildWnd::PreCreateWindow(cs) )
		return FALSE;
	return TRUE;
}

int CAnalyseFrame::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CMDIChildWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndDlgBar.Create(this, IDD_ANALYSE,CBRS_RIGHT|CBRS_TOOLTIPS|CBRS_FLYBY, IDD_ANALYSE))
	{
		TRACE0("Failed to create DlgBar\n");
		return -1;      // fail to create
	}

	DoPlacement(TRUE);	//GetIt
	return 0;
}

void CAnalyseFrame::OnDestroy() 
{
	CMDIChildWnd::OnDestroy();
	DoPlacement(FALSE);	//PutIt
}

void CAnalyseFrame::DoPlacement(BOOL bGetit)
{
	CSoundsApp *app=(CSoundsApp *)AfxGetApp();
	WINDOWPLACEMENT wp;
	if (bGetit) 
		wp=app->GetWP(ANALYSE);
	else
		this->GetWindowPlacement(&wp);

	app->SwitchWindowplacementAbsolutePercent(!bGetit,&wp);
	
	if (bGetit) 
		this->SetWindowPlacement(&wp);
	else
		app->PutWP(wp,ANALYSE);
}
