// FFTFrame.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "Sounds.h"
#include "FFTFrame.h"
#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFFTFrame

IMPLEMENT_DYNCREATE(CFFTFrame, CMDIChildWnd)

CFFTFrame::CFFTFrame()
{
}

CFFTFrame::~CFFTFrame()
{
}



BEGIN_MESSAGE_MAP(CFFTFrame, CMDIChildWnd)
	//{{AFX_MSG_MAP(CFFTFrame)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CFFTFrame Diagnose

#ifdef _DEBUG
void CFFTFrame::AssertValid() const
{
	CMDIChildWnd::AssertValid();
}

void CFFTFrame::Dump(CDumpContext& dc) const
{
	CMDIChildWnd::Dump(dc);
}

#endif //_DEBUG



/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten CFFTFrame 

BOOL CFFTFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	cs.style |= WS_THICKFRAME;
	cs.style |= WS_BORDER;
  cs.style |= (WS_MINIMIZEBOX|WS_MAXIMIZEBOX);
  if( !CMDIChildWnd::PreCreateWindow(cs) )
		return FALSE;

	return TRUE;
}


int CFFTFrame::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CMDIChildWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndDlgBar.Create(this, IDD_FFT_DLG,CBRS_RIGHT|CBRS_TOOLTIPS|CBRS_FLYBY, IDD_FFT_DLG))
	{
		TRACE0("Failed to create DlgBar\n");
		return -1;      // fail to create
	}
	if (*theApp.GetIniAllgemeinGrundschulprofil()) m_wndDlgBar.ShowWindow(SW_HIDE);	
	DoPlacement(TRUE);	//GetIt
	return 0;
}

void CFFTFrame::OnDestroy() 
{
	CMDIChildWnd::OnDestroy();
	DoPlacement(FALSE);	//PutIt
}

void CFFTFrame::DoPlacement(BOOL bGetit)
{
	CSoundsApp *app=(CSoundsApp *)AfxGetApp();
	WINDOWPLACEMENT wp;
	if (bGetit) 
		wp=app->GetWP(FFT);
	else
		this->GetWindowPlacement(&wp);

	app->SwitchWindowplacementAbsolutePercent(!bGetit,&wp);
	
	if (bGetit) 
		this->SetWindowPlacement(&wp);
	else
		app->PutWP(wp,FFT);
}

