#if !defined(AFX_WAVELETTRAFO_H__57E9E406_B33E_4133_9F67_FE5CCB0CC015__INCLUDED_)
#define AFX_WAVELETTRAFO_H__57E9E406_B33E_4133_9F67_FE5CCB0CC015__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// WaveletTrafo.h : Header-Datei
//
#include "Divisions.h"
//#define MachineTooFast

/////////////////////////////////////////////////////////////////////////////
// Befehlsziel CWaveletTrafo 

struct arguments
{
	const char*						signal;
	CString								wavelet;
	BOOL									usesignalrate;
	simple_division_range a;
	simple_division_range b;
	divisions							adiv; 
	BOOL									explicit_adiv;
	BOOL									explicit_nb;
	LONG									bminint;
	LONG									bmaxint;
	LONG									mi; 
	BOOL									explicit_mi;
	FLOAT									samplerate;
};		

/***********************************************************/
// Masterklasse fr CWT Transformation
/***********************************************************/
typedef const char* const_string;

class CWaveletTrafo
{
public:
	CWaveletTrafo(); 
	~CWaveletTrafo();

// Attribute
public:

public:
/*	const char *		m_pcSignal;
	CString					m_strWavelet;
	BOOL						m_bUseSignalRate;
	simple_division_range m_a;
	simple_division_range m_b;
	divisions				m_adiv;
	BOOL						m_bExplicit_adiv;
	bool						m_bExplicit_nb;
	long						m_longBMinInt;
	long						m_longBMaxInt;
	long						m_longMi;
	bool						m_bExplicit_mi;
	float						m_fSamplerate;
*/
	arguments				m_arguments;
protected:

// Operationen
public:
	void Start(SAMPLE* input,int input_length,CArray<FLOAT,FLOAT>* pPGMArray);
	bool is_prefix (const_string str, const_string prefix, const_string &end);
// berschreibungen
	// Vom Klassen-Assistenten generierte virtuelle Funktionsberschreibungen
	//{{AFX_VIRTUAL(CWaveletTrafo)
	//}}AFX_VIRTUAL

// Implementierung
public:
	void SetArguments();
protected:

	// Generierte Nachrichtenzuordnungsfunktionen
	//{{AFX_MSG(CWaveletTrafo)
		// HINWEIS - Der Klassen-Assistent fgt hier Member-Funktionen ein und entfernt diese.
	//}}AFX_MSG

};







/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ fgt unmittelbar vor der vorhergehenden Zeile zustzliche Deklarationen ein.

#endif // AFX_WAVELETTRAFO_H__57E9E406_B33E_4133_9F67_FE5CCB0CC015__INCLUDED_
